#define MAX_SEPERATION 90
#define MIN_SEPERATION 10
#define MAX_DEPTH 12
#define MIN_DEPTH 2

#define SLOPE (float)(MIN_DEPTH-MAX_DEPTH)/ (float)(MAX_SEPERATION-MIN_SEPERATION)
#define INTERCEPT (float)(MAX_DEPTH+SLOPE*MIN_SEPERATION)

int i;
static float depth_table[MAX_SEPERATION];


float linear_depth(int seperation) {
  return 12.8-(0.09*seperation);
}

float extract_depth(int x1, int y1, int x2, int y2) {

  int sep_delta = abs(x1-x2);
  if (sep_delta >MAX_SEPERATION)
    {
      return 1;
    }
  else 
    {
      return (SLOPE*sep_delta + INTERCEPT);
    }
}

float extract_depth_2nd_order(int x1, int y1, int x2, int y2) {
  int sep_delta = abs(x1-x2);
  if (sep_delta < MIN_SEPERATION)
    {
      return MAX_DEPTH;
    }
  else 
    {
      xil_printf("sep_delta: %d, sep_delta squared: %d", (int)sep_delta, sep_delta*sep_delta);
      return ((float)100000/(float)(sep_delta * sep_delta)*(float)(MAX_DEPTH));
    }  
}

float extract_depth_lookup(int x1, int y1, int x2, int y2) {
  int sep_delta = abs(x1-x2);
  if (sep_delta < MAX_SEPERATION) {
    return depth_table[sep_delta];
  }
  else {
    return 1;
  }
}
