//Ang Cui
//Kashif Siddiqui
#include "xbasic_types.h"
#include "xio.h"
#include "xparameters.h"
#include "xuartlite_l.h"
#include "xintc_l.h"


#define BUFF_SIZE 128
int uart_interrupt_count = 0;
char uart_character;


char write_buffer[BUFF_SIZE];
int read_pointer=0;
int write_pointer=0;

/*
 * Interrupt service routine for the UART
 */
void uart_handler(void *callback)
{
  Xuint32 IsrStatus;
  
  Xuint8 incoming_character;

  /* Check the ISR status register so we can identify the interrupt source */
  IsrStatus = XIo_In32(XPAR_MYUART_BASEADDR + XUL_STATUS_REG_OFFSET);
  
  if ((IsrStatus & (XUL_SR_RX_FIFO_FULL | XUL_SR_RX_FIFO_VALID_DATA)) != 0) {
    /* The input FIFO contains data: read it */
    incoming_character =
      (Xuint8) XIo_In32( XPAR_MYUART_BASEADDR + XUL_RX_FIFO_OFFSET );
    //XIo_Out32( XPAR_MYUART_BASEADDR + XUL_RX_FIFO_OFFSET, ' ');


    //disable interrupt
    //write char into buffer
    write_buffer[write_pointer] = incoming_character;
    write_pointer = (write_pointer + 1) % BUFF_SIZE;    
    //re enable interrupt

  
    uart_character = incoming_character;
    ++uart_interrupt_count;
  }
 
  if ((IsrStatus & XUL_SR_TX_FIFO_EMPTY) != 0) {
    /* The output FIFO is empty: we can send another character */
  }
   
}
